      double precision function map_steel_solvefer
     &(area,ans,v,sv,bi,alp,vol,xbar,xaga,xgag,tpre)
C
      implicit none                                    
      double precision area,ans,v,sv,bi,alp,alp1,xbar,xaga,xgag
      double precision limit,t1,t3,fac,vf1,f1,tpre
      double precision vf3,f3,t2,vf2,f2,vol,pi
      double precision map_steel_solvefer
      integer icount
C
C This function solves the time taken to reach a volume fraction v
C where kinetics are given by subroutine MAP_STEEL_AVOLF
C
C Need to define values for PI and for ALP1
C
      pi   = acos(0.0d+00)
      alp1 = alp*3.0D0
C
      if ((v .gt. 0.65) .or. (v .lt. 0.05)) then
           limit = 0.015
      else
           limit = 0.03
      endif
      if (v .gt. 1.0d-04) then
C Start by bracketing the solution
         icount = 0
         t1     = tpre*0.4
         t3     = tpre*1.2
         fac    = 2.d0
         area   = 0.0
         ans    = 0.0
         vol    = 0.0
1        continue
         call map_steel_avolf(area,ans,vf1,sv,bi,t1,alp,
     &   alp1,vol,xbar,xaga,xgag,pi)
         f1 = vf1-v
         call map_steel_avolf(area,ans,vf3,sv,bi,t3,alp,
     &   alp1,vol,xbar,xaga,xgag,pi)
         f3 = vf3-v
C Increment icount
         icount = icount+1
         if (icount .gt. 40 ) then
            write(6,*)' no bracketing in solvefer'
         endif
         if (f3 .lt. 0.0) then
             t3 = t3*fac
             goto 1
         endif
         if (f1 .gt. 0.0) then
             t1 = t1/fac
             goto 1
         endif
2        continue
         t2 = 0.5d0*(t1+t3)
C Increment icount
         icount = icount+1
         if (icount .gt. 40 ) then
            write(6,*)' No solution in solvefer'
            goto 3
         endif
         call map_steel_avolf(area,ans,vf2,sv,bi,t2,alp,
     &   alp1,vol,xbar,xaga,xgag,pi)
         f2 = vf2-v
         if (dabs(f2/v) .le. limit) goto 3
         if (f3*f2 .lt. 0) then
            t1 = t2
            f1 = f2
            goto 2
         else
            f3 = f2
            t3 = t2
            goto 2
         endif
3        continue
         map_steel_solvefer = t2
      else
         map_steel_solvefer = 0.0d0
         t2 = 0.0d0
      endif
C
      return
      end
C
C  Subroutine  MAP_STEEL_AVOLF
C  S.V. Parker and H.K.D.H. Bhadeshia
C
C
      SUBROUTINE MAP_STEEL_AVOLF(AREA,ANS,VF,SV,BI,TIME,ALP,ALP1,VOL,
     &XBAR,XAGA,XGAG,PI)
      IMPLICIT NONE
      DOUBLE PRECISION AREA,ANS,VF,SV,BI,TIME,ALP,VOL,XBAR,XAGA,XGAG
      DOUBLE PRECISION THETA(51),FUN(51),OMEGA,ALP1,PI,ARG
      INTEGER IDUM,I
      OMEGA=(XGAG-XBAR)/(XGAG-XAGA)
C
      DO 1, I=1,51
         IDUM=I-1
         THETA(I)=IDUM*2.0D-02
         ARG=0.5D+00*PI*BI*ALP1**2.0D+00*
     &       TIME**2.0D+00*(1.0D+00 - THETA(I)**4.0D+00)
         FUN(I)=1.0D+00 - DEXP(-ARG)
 1    CONTINUE
C
C
      CALL MAP_UTIL_TRAPE(THETA,FUN,ANS,51)
      ARG=2.0D+00*SV*ANS*ALP*TIME**0.5D+00/OMEGA
      VOL=1.0D+00 - DEXP(-ARG)
      VF=VOL*OMEGA
      AREA = FUN(1)
      RETURN
      END
